## Функциональное программирование. Семинар 1.

### Подстановка и бета-преобразование.

Выполните подстановки:
> (z y (\x -> x y) (\y -> y z) x)[y := v u]  
> (z y (\x -> x y) (\y -> y z) x)[z := y]  
> (z y (\x -> x y) (\y -> y z) x)[x :=  \v -> w (v t)]  
> (z y (\x -> x y) (\y -> y z) x)[z :=  \v -> w (v t)]  

Можно ли после этого сделать в термах бета-преобразование? Если да, выполните его:

Покажите, что:
> __I = S K K__  
> __K* = K I__  

### Пары

Попробуем построить простенький язык программирования с помощью лямбда-исчисления. Для этого нам понадобится научиться кодировать различные штуки -- кортежи, натуральные числа, булевы значения, списки и так далее. Кроме этого, мы научимся определять функции над сущностями, которые мы определили ранее.

Начнем с кортежей. Пару можно закодировать следующим образом:

> pair = \x y f -> f x y

Для пары нам понадобятся проекции. То есть функции, возвращающие первый и второй элемент пары. Реализуйте их:

> p1 = \p -> p K    
> p2 = \p -> p K*  

### Булевы значения

Булевы значения можно закодировать следующим образом:

> tru = \t f -> t  
> fls = \t f -> f  

Определим, например, отрицание:

> not = \b -> b fls tru

Несложно убедиться, что оно действительно работает. Определим конструкцию if:

> if = \c t e -> c t e

Определите прочие логические связки:

> or = \b1 b2 -> b1 tru b2
> and = \b1 b2 -> b1 b2 fls

Убедитесь, что они действительно работают

### Числа Чёрча

Нумералы Чёрча -- это способ закодировать натуральные числа в нашем исчислении.

> 0 = \s z -> z  
> 1 = \s z -> s z  
> 2 = \s z -> s (s z)  
> ...  
> n = \s z -> s (s (s ... z))

Идея в том, что число кодируется количеством раз, которым мы применили некоторую функцию `s` к аргументу `z`. Ноль -- ноль раз и так далее. Воспользовавшись этой мыслью, можно на самом деле сделать многое. Для начала нам понадобится умение прибавлять единицу.

> succ = \n s z -> s (n s z)  

Научившись прибавлять единицу, мы можем складывать два числа Чёрча.

> plus = \m n -> m succ n

Научившись складывать, напишите терм, перемножающий два числа Чёрча

>mult = \m n -> m (plus n) 0  

Заметьте, что я ничего не сказал про вычитание и деление. Их так же можно реализовать, но для этого понадобятся некоторые дополнительные знания. Мы увидим это на следующем занятии.

## Домашнее задание

1. Выделите свободные и связанные переменные в термах и осуществите подстановки:

    > x (\x y -> y (x w) u) y [x := \z -> z]  
    > (\x -> x (\y -> y x) w) (\x -> v) [w := y (\v -> v x)]

2. Уберите лишние скобки и осуществите бета-преобразование(если это возможно):

    > ((\x -> (\y -> ((x y) z))) (a (b c)))  
    > (((m n) m) (\x -> ((x (u v)) y)))  
    > ((\x -> (\y -> ((y x) x))) (x (x y)) y)

3. Покажите что

    > __B = S (K S) K__

4. Напишите терм, ведущий себя как логическая связка `xor`

    > xor = \b1 b2 -> ?

4. Напишите терм, возводящий число Чёрча в степень:

    > pow = \b e -> ?

5. (Опционально). Напишите терм, вычитающий единицу из числа Чёрча:

    > pred = \n -> ?
